/*
 * 
 *  dynamic linker command file
 *  generated: Sat Jan 22 09:07:51 2005

 *  kernel   : brickOS
 *  app start: 0xaedc
 * 
 *  BrickOS for LEGO(R) Mindstorms(TM)
 *  Originally: legOS - the independent LEGO Mindstorms OS
 *              (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2edc
  ram   : o = 0xaedc, l = 0x5020
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x001a ;
    _mm_try_join = 0x0122 ;
    _mm_defrag = 0x0160 ;
    _mm_update_first_free = 0x019e ;
    _mm_init = 0x01c4 ;
    _malloc = 0x0228 ;
    _free = 0x02ce ;
    _calloc = 0x02f8 ;
    _mm_reaper = 0x0340 ;
    _mm_free_mem = 0x036e ;
    _clock_handler = 0x03ac ;
    _subsystem_handler = 0x03d0 ;
    _task_switch_handler = 0x0432 ;
    _systime_tm_return = 0x044c ;
    _systime_init = 0x0460 ;
    _systime_shutdown = 0x04d8 ;
    _systime_set_switcher = 0x04ea ;
    _systime_set_timeslice = 0x04f0 ;
    _get_system_up_time = 0x050e ;
    _tm_switcher = 0x0524 ;
    _tm_scheduler = 0x0540 ;
    _yield = 0x06dc ;
    _tm_man_task = 0x06fa ;
    _tm_battery_task = 0x073e ;
    _tm_init = 0x078c ;
    _tm_start = 0x07fa ;
    _execi = 0x080c ;
    _exit = 0x09ac ;
    _wait_event = 0x09ce ;
    _msleep = 0x0a78 ;
    _sleep = 0x0ab4 ;
    _shutdown_task = 0x0ad8 ;
    _shutdown_tasks = 0x0ae4 ;
    _kill = 0x0b34 ;
    _killall = 0x0b70 ;
    _sem_event_wait = 0x0bf2 ;
    _sem_wait = 0x0c0c ;
    _sem_timedwait = 0x0c80 ;
    _sem_trywait = 0x0cc8 ;
    _delay = 0x0ce0 ;
    _cputc_native = 0x0d00 ;
    _cputc_native_0 = 0x0d2e ;
    _cputc_native_1 = 0x0d62 ;
    _cputc_native_2 = 0x0d98 ;
    _cputc_native_3 = 0x0dd2 ;
    _cputc_native_4 = 0x0e0e ;
    _cputc_native_5 = 0x0e4a ;
    _cputw = 0x0e56 ;
    _cputs = 0x0e9a ;
    _cls = 0x0ee2 ;
    _lcd_number = 0x0eea ;
    _lcd_refresh_next_byte = 0x0f8e ;
    _lcd_refresh_next_byte_core = 0x0fa2 ;
    _lcd_refresh = 0x0ff2 ;
    _lcd_power_on = 0x1022 ;
    _lcd_power_off = 0x1034 ;
    _lcd_init = 0x1050 ;
    _rx_handler = 0x109a ;
    _rx_core = 0x10ae ;
    _rxerror_handler = 0x1116 ;
    _rxerror_core = 0x112a ;
    _txend_handler = 0x116c ;
    _txend_core = 0x1180 ;
    _tx_handler = 0x118e ;
    _tx_core = 0x11a2 ;
    _lnp_logical_shutdown = 0x11ca ;
    _lnp_logical_init = 0x11ea ;
    _lnp_logical_write = 0x12b0 ;
    _lnp_integrity_write = 0x1378 ;
    _lnp_addressing_write = 0x13da ;
    _lnp_receive_packet = 0x146e ;
    _lnp_integrity_byte = 0x14ec ;
    _lnp_integrity_reset = 0x16ce ;
    _lnp_integrity_reset_core = 0x16e2 ;
    _lnp_timeout_reset = 0x1710 ;
    _lnp_timeout_reset_core = 0x1724 ;
    _lnp_init = 0x172e ;
    _msg_received = 0x1750 ;
    _send_msg = 0x17b6 ;
    _lnp_integrity_active = 0x1814 ;
    _lnp_timeout_set = 0x1820 ;
    _lr_getdata = 0x182a ;
    _lr_process = 0x1852 ;
    _lr_waitdata = 0x18c6 ;
    _lr_thread = 0x18fc ;
    _lr_init = 0x1930 ;
    _lr_startup = 0x193a ;
    _lr_shutdown = 0x197e ;
    _program_valid = 0x1992 ;
    _program_stop = 0x1d4e ;
    _key_handler = 0x1dca ;
    _lrkey_handler = 0x2076 ;
    _program_init = 0x22a2 ;
    _program_shutdown = 0x2302 ;
    _vis_handler = 0x2310 ;
    _vis_core = 0x2324 ;
    _get_battery_mv = 0x237e ;
    _shutoff_restart = 0x23a8 ;
    _shutoff_init = 0x23b8 ;
    _autoshutoff_check = 0x23c4 ;
    _autoshutoff_check_core = 0x23d8 ;
    _dkey_handler = 0x2408 ;
    _dkey_pressed = 0x2446 ;
    _dkey_released = 0x2468 ;
    _getchar = 0x2488 ;
    _dm_init = 0x24b2 ;
    _dm_shutdown = 0x24b6 ;
    _motor_a_dir = 0x24d8 ;
    _motor_b_dir = 0x251a ;
    _motor_c_dir = 0x2560 ;
    _ds_rotation_set = 0x25a4 ;
    _ds_rotation_handler = 0x25f8 ;
    _ds_init = 0x26f0 ;
    _ds_shutdown = 0x2726 ;
    _dsound_handler = 0x273e ;
    _dsound_core = 0x2752 ;
    _dsound_init = 0x2848 ;
    _dsound_shutdown = 0x2860 ;
    _dsound_stop = 0x2864 ;
    _dsound_finished = 0x2884 ;
    _atomic_inc = 0x289e ;
    _atomic_dec = 0x28ac ;
    _locked_check_and_increment = 0x28ba ;
    _wait_critical_section = 0x28f4 ;
    _enter_critical_section = 0x2916 ;
    _setjmp = 0x2944 ;
    _longjmp = 0x2960 ;
    _memcpy = 0x2974 ;
    _memset = 0x2986 ;
    ___mulhi3 = 0x2994 ;
    ___udivhi3 = 0x29a4 ;
    ___mulsi3 = 0x29b6 ;
    ___divsi3 = 0x29d2 ;
    _hex_display_codes = 0x2a1c ;
    _ascii_display_codes = 0x2a2c ;
    _lnp_rcx_header = 0x2abe ;
    _lnp_rcx_remote_op = 0x2ac0 ;
    _lnp_rcx_msg_op = 0x2ac2 ;
    _min_length = 0x2aec ;
    _dm_a_pattern = 0x2b1c ;
    _dm_b_pattern = 0x2b20 ;
    _dm_c_pattern = 0x2b24 ;
    _firmware_string = 0x2c06 ;
    _etext = 0x2c06 ;
    _lcd_refresh_period = 0x2c08 ;
    _lnp_hostaddr = 0x2c0a ;
    _lnp_timeout = 0x2c0c ;
    _lr_dataready = 0x2c0e ;
    _vis_refresh_counter = 0x2c10 ;
    _vis_refresh_period = 0x2c11 ;
    _battery_refresh_counter = 0x2c12 ;
    _battery_refresh_period = 0x2c14 ;
    _auto_shutoff_counter = 0x2c16 ;
    _auto_shutoff_period = 0x2c18 ;
    _auto_shutoff_secs = 0x2c1a ;
    _auto_shutoff_elapsed = 0x2c1c ;
    _idle_powerdown = 0x2c1e ;
    _dsound_system_sounds = 0x2c20 ;
    __edata = 0x2c22 ;
    _bss_start = 0x2c30 ;
    _mm_first_free = 0x2e1a ;
    _tm_timeslice = 0x2e1c ;
    _tm_current_slice = 0x2e1d ;
    _tm_switcher_vector = 0x2e1e ;
    _sys_time = 0x2e20 ;
    _ctid = 0x2e30 ;
    _td_single = 0x2e40 ;
    _nb_tasks = 0x2e54 ;
    _priority_head = 0x2e56 ;
    _nb_system_tasks = 0x2e58 ;
    _lcd_byte_counter = 0x2e5a ;
    _lcd_refresh_counter = 0x2e5b ;
    _tx_state = 0x2e5c ;
    _lnp_rcx_checksum = 0x2e60 ;
    _lnp_integrity_handler = 0x2e62 ;
    _lnp_rcx_message = 0x2e64 ;
    _lnp_rcx_temp1 = 0x2e65 ;
    _lnp_timeout_counter = 0x2e66 ;
    _lnp_addressing_handler = 0x2e70 ;
    _lnp_remote_handler = 0x2e90 ;
    _lnp_integrity_state = 0x2e92 ;
    _lnp_rcx_temp0 = 0x2e94 ;
    _lr_curkeys = 0x2e98 ;
    _lr_data = 0x2e9a ;
    _EventType = 0x2e9c ;
    _lr_handler = 0x2e9e ;
    _lr_tid = 0x2ea0 ;
    _lr_timeoff = 0x2ea4 ;
    _packet_len = 0x2ea8 ;
    _cprog = 0x2eaa ;
    _packet_src = 0x2eac ;
    _dkey_timer = 0x2eae ;
    _dkey = 0x2eaf ;
    _dkey_multi = 0x2eb0 ;
    _dm_a = 0x2eb4 ;
    _dm_b = 0x2eb8 ;
    _dm_c = 0x2ebc ;
    _ds_rotation = 0x2ec0 ;
    _ds_channel = 0x2ec1 ;
    _ds_rotations = 0x2ec4 ;
    _ds_activation = 0x2eca ;
    _dsound_next_note = 0x2ecc ;
    _dsound_internote_ms = 0x2ece ;
    _dsound_16th_ms = 0x2ed0 ;
    _dsound_next_time = 0x2ed4 ;
    _kernel_critsec_count = 0x2ed8 ;
    _end = 0x2eda ;
    _mm_start = 0x2eda ;
    _dm_handler = 0x7002 ;
    ___etext_hi = 0x704a ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _WDT_CSR = 0xa8 ;
    _WDT_CNT = 0xa9 ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
